#include <stdio.h>
#include <string.h>		// strlen()
#include <unistd.h>		// read, write
#include <fcntl.h>		// open, close, O_RDWR, O_NONBLOCK
//#include <time.h>
#include <sys/time.h>
#include <pthread.h>
#include <sys/poll.h>

#define BUFF_SIZE 2000
//#define BUFF_SIZE (1048*80)
#define INF_LOOP 1
#define WRITE_COUNT 1
#define SEND_CNT 1

extern int fd[4];

static unsigned int frame_size[4] = {0,0,0,0};
static unsigned long int g_frame_size[4] = {0,0,0,0};

unsigned int GetMSec()
{
	unsigned int uiCurTime;
	struct timeval tv;

	gettimeofday(&tv, NULL);

	uiCurTime = tv.tv_sec * 1000 + tv.tv_usec/1000;

	return uiCurTime;
}

void *timer_thread(void *arg)
{
	unsigned int uiStartTime = 0;
	unsigned int uiCurrTime = 0;
	int iTickInterVal = 1000;
	int uiTickCount = 0;
	int ch = 0;

	uiStartTime = GetMSec();
	while(1)
	{
		uiCurrTime = GetMSec();
		if( (uiCurrTime - uiStartTime) >= iTickInterVal )
		{
			uiTickCount++;
//			printf("[%d] Rx[%d] %5.3f Gbps (%ld)\n", uiTickCount, ch, g_frame_size[ch] * 8   / 1000000000.f, frame_size[ch]);
			printf("[%d] Rx[0] %5.3f Gbps (%ld), Rx[1] %5.3f Gbps (%ld), Rx[2] %5.3f Gbps (%ld), Rx[3] %5.3f Gbps (%ld)\n", uiTickCount, g_frame_size[0] * 8   / 1000000000.f, frame_size[0], g_frame_size[1] * 8   / 1000000000.f, frame_size[1], g_frame_size[2] * 8   / 1000000000.f, frame_size[2], g_frame_size[3] * 8   / 1000000000.f, frame_size[3]);
			g_frame_size[0] = 0;
			g_frame_size[1] = 0;
			g_frame_size[2] = 0;
			g_frame_size[3] = 0;
			uiStartTime = uiCurrTime;
		}
		usleep(100000);
	}
	return NULL;
}

void *send_thread(void* arg)
{
	int ch = 0;
	unsigned int buff[BUFF_SIZE];
	unsigned int i, j = 0;
	unsigned int pattern = 0;
	int rtn = 0;
	int cnt = 0;


	ch = *(int *)arg;

	printf("Send_thread[%d] \n", ch);
	memset(buff,pattern,BUFF_SIZE);

	for(i=0; i < BUFF_SIZE ; i++)
	{
		buff[i] = pattern;
		pattern++;
	}

//		printf("[1]%d [2]%d [1024]%d [102399]%d [102400]%d \n", buff[1], buff[2], buff[1024], buff[102399], buff[102400] );
	while(1)
	{
		for(cnt = 0; cnt < WRITE_COUNT; cnt++) {
			buff[0] = j++;
			if(ch == 0)
				rtn = sdlc_send(ch, buff, BUFF_SIZE);
			else if(ch == 1)
				rtn = sdlc_send(ch, buff, 1000);
			else if(ch == 2)
				rtn = sdlc_send(ch, buff, 200);
			else if(ch == 3)
				rtn = sdlc_send(ch, buff, 100);
				
			if(rtn < 0)
			{
				usleep(1000);
			}
		}
//		break;
	}

	return;
}

void *recv_thread(void* arg)
{
	int ch = 0;
	struct pollfd poll_events;
	int poll_state;
	unsigned int buff[BUFF_SIZE];
	int ret;
	int i;
	int rtn = 0;

	ch = *(int *)arg;

	poll_events.fd        = fd[ch];
	poll_events.events    = POLLIN | POLLERR;          // 수신된 자료가 있는지, 에러가 있는지
	poll_events.revents   = 0;

	printf("Recv_thread[%d] \n", ch);

	while(1) {
		poll_state = poll(                               // poll()을 호출하여 event 발생 여부 확인
				(struct pollfd*)&poll_events, // event 등록 변수
				1,  // 체크할 pollfd 개수
				10000   // time out 시간
				);
		if ( 0 < poll_state)                             // 발생한 event 가 있음
		{
			if(poll_events.revents & POLLIN)            // event 가 자료 수신?
			{
				ret = sdlc_recv(ch, buff, BUFF_SIZE);

				while(ret > 0)
				{
					frame_size[ch] = ret;
					g_frame_size[ch] += frame_size[ch];

#if 0
					for(i=501; i<520; i++)
					{
						printf("CH[%d] len[%d] recv %d[0x%08x]  ", ch, ret, i, buff[i]);
						if( (i%5) == 0 )
							printf("\n");
					}
					printf("\n\n");
#endif
				//	printf("ch[%d] len[%d] %d[0x%08x] %d[0x%08x] %d[0x%08x] %d[0x%08x] %d[0x%08x] %d[0x%08x] %d[0x%08x] %d[0x%08x]\n", ch, ret, 23, buff[23], 24, buff[24], 48, buff[48], 49, buff[49], 249, buff[249], 250, buff[250], 499, buff[499], 500, buff[500] );
					memset(buff, 0, BUFF_SIZE*4);
					ret = sdlc_recv(ch, buff, BUFF_SIZE);
				}
			}
			if(poll_events.revents & POLLERR)      // event 가 에러?
			{
				printf( "poll_events.revents & POLLERR\n");
				break;
			}
		}
	} //while


	return NULL;
}



int main(int argc, char **argv)
{
	int chNum[4] = {0, 1, 2, 3};

	pthread_t p_send0;
	pthread_t p_send1;
	pthread_t p_send2;
	pthread_t p_send3;

	pthread_t p_recv0;
	pthread_t p_recv1;
	pthread_t p_recv2;
	pthread_t p_recv3;
	pthread_t p_tick_thread;

	int iSendThreadID0;
	int iSendThreadID1;
	int iSendThreadID2;
	int iSendThreadID3;

	int iRecvThreadID0;
	int iRecvThreadID1;
	int iRecvThreadID2;
	int iRecvThreadID3;
	int iTickThreadID;

	sdlc_init();

	iTickThreadID = pthread_create(&p_tick_thread, NULL, timer_thread, NULL);

	iSendThreadID0 = pthread_create(&p_send0, NULL, send_thread, (void *)&chNum[0]);
	iSendThreadID1 = pthread_create(&p_send1, NULL, send_thread, (void *)&chNum[1]);
	iSendThreadID2 = pthread_create(&p_send2, NULL, send_thread, (void *)&chNum[2]);
	iSendThreadID3 = pthread_create(&p_send3, NULL, send_thread, (void *)&chNum[3]);
	iRecvThreadID0 = pthread_create(&p_recv0, NULL, recv_thread, (void *)&chNum[0]);
	iRecvThreadID1 = pthread_create(&p_recv1, NULL, recv_thread, (void *)&chNum[1]);
	iRecvThreadID2 = pthread_create(&p_recv2, NULL, recv_thread, (void *)&chNum[2]);
	iRecvThreadID3 = pthread_create(&p_recv3, NULL, recv_thread, (void *)&chNum[3]);

	pthread_join(p_send0, NULL);
	pthread_join(p_recv0, NULL);
	pthread_join(p_recv1, NULL);
	pthread_join(p_recv2, NULL);
	pthread_join(p_recv3, NULL);

	sdlc_close();
	return 0;

}


