/*
 * SDLC or HDLC functions. 
 */
#include <stdio.h>
#include <string.h>	 // strlen()
#include <unistd.h>	 // read, write
#include <fcntl.h>	 // open, close, O_RDWR, O_NONBLOCK
#include "seedcore_api.h"


int fd[4];	/* file ids for HDLC device file. */
int temp_size[4];
unsigned int temp[4][BUFSIZE];


int sdlc_send( int ch, unsigned int* buf, int size)
{
	int rtn;
	int idx = 0;

#if 0	
	while(size > 0)
	{
		rtn = write(fd[ch], &buf[(BUFSIZE/4)*idx], (size>BUFSIZE ? BUFSIZE : size));
		if(rtn < 0) return -1;
		size -= BUFSIZE;
		idx++;
	}
	return 0;
#endif
	rtn = write( fd[ch], buf, size );	/* return: size */

	if(rtn < 0) return -1;
	return rtn; 
}


int sdlc_recv(int ch, unsigned int* buf, int size)
{
	int ret;
	int cnt = 0;
	int idx = 0;
	int i = 0;

#if 0
	if(temp_size[ch] >= size) {
		memcpy(buf, &temp[ch][(BUFSIZE-temp_size[ch])/4], size);
		temp_size[ch] -= size;
		size = 0;
	}
	else if(temp_size[ch] > 0) {
		memcpy(buf, temp[ch], temp_size[ch]);
		size -= temp_size[ch];
		idx = temp_size[ch];
		temp_size[ch] = 0;
	}

	while(size > 0) {
		ret = read(fd[ch], temp[ch], BUFSIZE);
		if(ret > 0) 
		{
			if(size < BUFSIZE) {
				memcpy(&buf[(idx/4) + (BUFSIZE/4)*cnt], temp[ch], size);
				temp_size[ch] = BUFSIZE - size;
				size -= size;
			}
			else {
				memcpy(&buf[(idx/4) + (BUFSIZE/4)*cnt], temp[ch], BUFSIZE);
				size -= BUFSIZE;
				cnt++;
				temp_size[ch] = 0;
			}
		}
	} //while
	return 0;
#endif
	ret = read( fd[ch], buf, BUFSIZE );
	return ret;
}


int sdlc_init()
{
	int i;
	char str[255];

	for( i=0; i<NUM_OF_HDLC_CHS; i++ ) {
		sprintf( str, "/dev/%s%d", HDLC_DEV_NAME, i);
		fd[i] = open( str, O_RDWR | O_SYNC ); 
		if( (fd[i] == 0) | (fd[i] < 0) ) 
			printf( "HDLC device file(%s) open error. id: %d.\n", str, fd[i] );
	}
	return 0;
}


int sdlc_close()
{
	int i = 0;

	for( i=0; i<4; i++ )  close(fd[i]);
	return 0;
}

