#ifndef _DBG_
#define _DBG_

#define XDMA_DEBUG  1 

/* disable debugging */
#if (XDMA_DEBUG == 0)
	#define dbg_desc(...)
	#define dbg_io(...)
	#define dbg_fops(...)
	#define dbg_perf(fmt, ...)
	#define dbg_sg(...)
	#define dbg_tfr(...)
	#define dbg_irq(...)
	#define dbg_init(...)

#else
	/* descriptor, ioread/write, scatter-gather, transfer debugging */
	#define dbg_desc(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

	#define dbg_io(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

	#define dbg_fops(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

	#define dbg_perf(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

	#define dbg_sg(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

	#define dbg_irq(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

	#define dbg_init(fmt, ...) pr_debug("%s():" fmt, \
		__func__, ##__VA_ARGS__)

#endif

#endif	/*__DBG__*/

