/*
 * This is a Header file for HDLC API.
 * Copyriht 2021(c) SEEDCORE Inc. Jeongki Kim.
 */

#ifndef __HDLCAPI__
#define __HDLCAPI__

#include <sys/types.h>

#ifndef IOCTLTEST_MAGIC
#define IOCTLTEST_MAGIC    't'
#endif

#define IOCTL_GET_REG		_IO(IOCTLTEST_MAGIC, 6)
#define IOCTL_SET_REG		_IO(IOCTLTEST_MAGIC, 7)
#define IOCTL_GET_DROP_CNT	_IO(IOCTLTEST_MAGIC, 8)
#define IOCTL_RESET		_IO(IOCTLTEST_MAGIC, 9)

#define HDLC_DEV_NAME	"schdlc" 

/* define the mode when data is received */
#define RXMODE_PATTERN		0x5555AAAA 
#define RXMODE_AFTER_PATTERN	1 
#define RXMODE_WITHOUT_PATTERN	0 

/* It defines the Data Frame Size to send and recv from BD frames.
 * It should be the same as or larger (>=) than that of BD. */
#define MAX_FRMSIZE	(1024*2)
#define RX_FRMSIZE	MAX_FRMSIZE
#define TX_FRMSIZE	MAX_FRMSIZE

#define NUM_OF_DMA	4

/* define User Buffer size */
#define USER_BUFSIZE	(1024*32)
#define TX_BUFSIZE	USER_BUFSIZE
#define RX_BUFSIZE	USER_BUFSIZE


typedef struct pcidrv_ioctl_val {
	u_int		val;
	volatile u_long	addr;

} __attribute__ ((packed)) PCIDRV_INFO;


int hdlc_start(int ch, int mode);
int hdlc_send(int ch, char* buf, int size);
int hdlc_recv_single(int ch, char *buf, int size);
int hdlc_recv(int ch, char* buf, int size, int usrtimeout);
int hdlc_init();
int hdlc_bdbuf_clear();
int hdlc_ch_open();
int hdlc_ch_close();
int hdlc_all_open();
int hdlc_all_close();
int hdlc_reset(int ch);
int hdlc_bd_reset();

#endif

