/*
 * This is functions to read register values. 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>	     // strlen()
#include <unistd.h>	     // read, write
#include <fcntl.h>	      // open, close, O_RDWR, O_NONBLOCK
#include <sys/types.h>
#include <sys/ioctl.h>
// #include <linux/types.h>

#include "hdlc-api.h"

#define MAX_OFFSET_NUM  63      /* Max Offset Address */

extern int fd[];


unsigned int get_main_arg( int argc, char **argv )
{
	unsigned int roffset;
	char addrstr[128];


	if( argc != 2 ) printf( "\nUsage: %s <Hex Addr(x10000)>\n\n", argv[0] );
	if( argc > 2 ) return -1;

	while(1) {
		if( argc == 1 ) {
			printf( "Range of the addr is from 0 to %X (x10000). ", MAX_OFFSET_NUM );
			printf( "Addr(Hex)?: " );
			scanf( "%s", addrstr );
			roffset = strtol( addrstr, NULL, 16 );
		}
		else if( argc == 2 ) {
			roffset = strtol( argv[1], NULL, 16 );
		}

		if( roffset <0 || roffset > MAX_OFFSET_NUM ) {
			printf( "Range of the Addr is over: %X.\n", roffset );
			argc = 1;
			continue;
		}
		else break;
	}
	printf( "Offset: 0x%X\n", (roffset*0x10000) );
	return (roffset*0x10000);
}


	
int main( int argc, char **argv )
{
	unsigned int baseaddr;
	char devfilename[128];
	PCIDRV_INFO pi;
	int i;


	baseaddr = get_main_arg( argc, argv ); 
	printf( "Excute: %s %Xh.\n\n", argv[0], baseaddr );

	if( hdlc_ch_open(0) < 0 )	return -1;

	for( i=0; i<32; i++ ) {

		pi.addr = baseaddr + 0x04*i;
		ioctl(fd[0], IOCTL_GET_REG, &pi);
		printf( "HDLC Register 0x%02X 0x%08X \n", pi.addr, pi.val);
	}

	hdlc_ch_close(0);
	return 0;
}

