
#include <stdio.h>
#include <string.h>		// strlen()
#include <unistd.h>		// read, write
#include <fcntl.h>		// open, close, O_RDWR, O_NONBLOCK
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include "my_ioctl.h"

#define XAXIDMA_TX_CR_OFFSET    0x00000000 /* Channel control */
#define XAXIDMA_TX_SR_OFFSET    0x00000004 /* Status */
#define XAXIDMA_DELAY_MASK      0xFF000000 /* Delay timeout counter */
#define XAXIDMA_COALESCE_MASK       0x00FF0000 /* Coalesce counter */

#define XAXIDMA_CR_RESET_MASK   0x00000004 /* Reset DMA engine */

#define XAXIDMA_DELAY_SHIFT     24
#define XAXIDMA_COALESCE_SHIFT      16

#define XAXIDMA_DFT_TX_THRESHOLD    32
#define XAXIDMA_DFT_TX_WAITBOUND    254
#define XAXIDMA_DFT_RX_THRESHOLD    32
#define XAXIDMA_DFT_RX_WAITBOUND    254

#define XAXIDMA_IRQ_ALL_MASK        0x00007000 /* All interrupts */

int main()
{
	int fd;
	PCIDRV_INFO pi;
	unsigned long timeout;
	int i;

	if (0 < (fd = open ("/dev/pcidrv", O_RDWR | O_SYNC)))
//	if (0 < (fd = open ("/dev/scSdlc", O_RDWR | O_SYNC)))
	{
		printf("***open()\n");

		for(i=0; i<4; i++) {
			pi.addr = 0x10000 + (0x10000*i) + 0x00;
//			pi.val = 0xfe207003;
//			ioctl(fd, IOCTL_SET_REG, &pi);
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x00 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x04;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x04 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x08;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x08 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x0c;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x0c 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x10;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x10 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x14;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x14 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x18;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x18 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x1c;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x1c 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x28;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x28 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x2c;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x2c 0x%08x\n", i, pi.val);


			pi.addr = 0x10000 + (0x10000*i) + 0x30;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x30 0x%08x\n", i, pi.val);

			pi.addr = 0x10000 + (0x10000*i) + 0x34;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC-DMA[%d] 0x34 0x%08x\n", i, pi.val);

			pi.addr = 0x30000 + (0x10000*i) + 0x04;
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SDLC[%d] Baud 0x04 0x%08x\n", i, pi.val);

			printf("\n");
		}

		pi.addr = 0x90000 + 0x04;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("SDLC[IRQ] Build date 0x04 0x%08x\n", pi.val);
		printf("\n");

#if 0
		pi.addr = 0x90000 + 0x00;
		pi.val = 0x0;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("SDLC[IRQ] 0x00 0x%08x\n", pi.val);

		pi.addr = 0x90000 + 0x04;
		pi.val = 0x0;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("SDLC[IRQ] 0x04 0x%08x\n", pi.val);

		pi.addr = 0x90000 + 0x10;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("IRQ Mask 0x%08x\n", pi.val);

		pi.addr = 0x90000 + 0x14;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("IRQ Status 0x%08x\n", pi.val);

		ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("IRQ Status 0x%08x\n", pi.val);
#endif

		close(fd);
		printf("***close()\n");
	} else 
		printf("open fail \n");

	return 0;
}
