
#include <stdio.h>
#include <string.h>		// strlen()
#include <unistd.h>		// read, write
#include <fcntl.h>		// open, close, O_RDWR, O_NONBLOCK
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include "my_ioctl.h"

#define XAXIDMA_TX_CR_OFFSET    0x00000000 /* Channel control */
#define XAXIDMA_TX_SR_OFFSET    0x00000004 /* Status */
#define XAXIDMA_DELAY_MASK      0xFF000000 /* Delay timeout counter */
#define XAXIDMA_COALESCE_MASK       0x00FF0000 /* Coalesce counter */

#define XAXIDMA_CR_RESET_MASK   0x00000004 /* Reset DMA engine */

#define XAXIDMA_DELAY_SHIFT     24
#define XAXIDMA_COALESCE_SHIFT      16

#define XAXIDMA_DFT_TX_THRESHOLD    32
#define XAXIDMA_DFT_TX_WAITBOUND    254
#define XAXIDMA_DFT_RX_THRESHOLD    32
#define XAXIDMA_DFT_RX_WAITBOUND    254

#define XAXIDMA_IRQ_ALL_MASK        0x00007000 /* All interrupts */

int main()
{
	int fd;
	PCIDRV_INFO pi;
	unsigned long timeout;
	int i;

	if (0 < (fd = open ("/dev/pcidrv3", O_RDWR | O_SYNC)))
	{
		printf("***open()\n");


// SFPDP reset
#if 0

//ch 0
#if 1
		pi.addr = 0x5000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x50018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x5000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[0]SFPDP CR 0x%08x\n\n", pi.val);

		usleep(1000*1000);

#endif




//ch 1
#if 1
		pi.addr = 0x6000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[1]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x60018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[1]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[1]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x6000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[1]SFPDP CR 0x%08x\n\n", pi.val);
	
		usleep(1000*1000);
#endif

//ch 2
#if 1
		pi.addr = 0x7000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[2]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x70018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[2]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[2]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x7000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[2]SFPDP CR 0x%08x\n\n", pi.val);

		usleep(1000*1000);
#endif


//ch 3
#if 1
		pi.addr = 0x8000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x80018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x8000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[3]SFPDP CR 0x%08x\n\n", pi.val);

		usleep(1000*1000);
#endif

#endif


// serial loopback set
#if 0
//ch 0
#if 1
		pi.addr = 0x5000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x50018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		pi.val |= 0x0004;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x5000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[0]SFPDP CR 0x%08x\n\n", pi.val);

		usleep(1000*1000);

#endif




//ch 1
#if 1
		pi.addr = 0x6000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[1]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x60018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[1]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		pi.val |= 0x0004;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[1]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x6000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[1]SFPDP CR 0x%08x\n\n", pi.val);
	
		usleep(1000*1000);
#endif

//ch 2
#if 1
		pi.addr = 0x7000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[2]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x70018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[2]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		pi.val |= 0x0004;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[2]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x7000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[2]SFPDP CR 0x%08x\n\n", pi.val);

		usleep(1000*1000);
#endif


//ch 3
#if 1
		pi.addr = 0x8000C;
		pi.val = 0x01;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x80018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.val = 0x00600003;
		pi.val |= 0x0004;
		ioctl(fd, IOCTL_SET_REG, &pi);

		usleep(1000*100);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x8000C;
                pi.val = 0x00;
                ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
                printf("[3]SFPDP CR 0x%08x\n\n", pi.val);

		usleep(1000*1000);
#endif

#endif



// read cr/sr
#if 0
		pi.addr = 0x50018;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x10034;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SR 0x%08x\n", pi.val);

		pi.addr = 0x40030;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]CR 0x%08x\n", pi.val);

		pi.addr = 0x40034;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SR 0x%08x\n", pi.val);
#endif

// dma reset
#if 0 

		pi.addr = 0x20030;

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]CR 0x%08x\n", pi.val);
		pi.val = 0x0004;
		ioctl(fd, IOCTL_SET_REG, &pi);

		timeout = 1000;
		ioctl(fd, IOCTL_GET_REG, &pi);
		do{
			usleep(1);
			if (--timeout == 0) {
				printf("DMA reset timeout!\n");
				break;
			}
			ioctl(fd, IOCTL_GET_REG, &pi);
		} while (pi.val & XAXIDMA_CR_RESET_MASK);


		ioctl(fd, IOCTL_GET_REG, &pi);
		pi.val = (pi.val & ~XAXIDMA_COALESCE_MASK) | (XAXIDMA_DFT_TX_THRESHOLD << XAXIDMA_COALESCE_SHIFT);
		pi.val = (pi.val & ~XAXIDMA_DELAY_MASK) | (XAXIDMA_DFT_TX_WAITBOUND << XAXIDMA_DELAY_SHIFT);
		pi.val |= XAXIDMA_IRQ_ALL_MASK;
		pi.val |= 0x0001;
		ioctl(fd, IOCTL_SET_REG, &pi);

		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("pi.val 0x%08x\n", pi.val);
#endif

//read cr/sr
#if 0
		while(1) {
		printf("**********************************\n");
		pi.addr = 0x10000;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]CR 0x%08x\n", pi.val);

		pi.addr = 0x20030;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[1]CR 0x%08x\n", pi.val);

		pi.addr = 0x30000;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[2]CR 0x%08x\n", pi.val);

		pi.addr = 0x40030;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]CR 0x%08x\n\n", pi.val);


		pi.addr = 0x10000;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[0]SR 0x%08x\n", pi.val);

		pi.addr = 0x20034;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[1]SR 0x%08x\n", pi.val);

		pi.addr = 0x30004;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[2]SR 0x%08x\n", pi.val);

		pi.addr = 0x40034;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SR 0x%08x\n\n", pi.val);


		pi.addr = 0x50018;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x60018;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x70018;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n", pi.val);

		pi.addr = 0x80018;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("[3]SFPDP CR 0x%08x\n\n", pi.val);
		usleep(500000);
		printf("**********************************\n\n");
		}
#endif


// example
#if 0
		pi.addr = 0x50008;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("0x5xxxx 0x%08x\n", pi.val);

		pi.val = 0x00ab;
		ioctl(fd, IOCTL_SET_REG, &pi);

		pi.val = 0x0000;
		printf("0x5xxxx 0x%08x\n", pi.val);
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf("0x5xxxx 0x%08x\n", pi.val);
#endif


		close(fd);
		printf("***close()\n");
	} else 
		printf("open fail \n");

	return 0;
}
